<html>

<head>
    <title>Push Demo</title>
    <style>
        input {
            background: none;
            border: 1px solid black;
            padding: 4px;
            height: 30px;
            font-size: 16px;
            color: blue;
        }
    </style>
    <script>
        function urlBase64ToUint8Array(base64String) {
            const padding = '='.repeat((4 - (base64String.length % 4)) % 4);
            const base64 = (base64String + padding)
                .replace(/-/g, '+')
                .replace(/_/g, '/');
            const rawData = window.atob(base64);
            const outputArray = new Uint8Array(rawData.length);
            for (let i = 0; i < rawData.length; ++i) {
                outputArray[i] = rawData.charCodeAt(i);
            }
            return outputArray;
        }
        if ('serviceWorker' in navigator) {
            console.log('Registering service worker');
        }

        async function run() {
            console.log('Registering service worker');
            const registration = await navigator.serviceWorker.register('worker.js', {
                scope: '/pubs/'
            });
            console.log('Registered service worker');

            console.log('Registering push');
            const subscription = await registration.pushManager.subscribe({
                userVisibleOnly: true,
                // The `urlBase64ToUint8Array()` function is the same as in
                // https://www.npmjs.com/package/web-push#using-vapid-key-for-applicationserverkey
                applicationServerKey: urlBase64ToUint8Array(
                    document.getElementById('pubkey').value
                )
            });
            console.log('Registered push');

            console.log('Sending push');
            await fetch(document.getElementById('server').value, {
                method: 'POST',
                body: JSON.stringify({
                    id_user: document.getElementById('customid').value,
                    subs: subscription
                }),
                headers: {
                    'content-type': 'application/json'
                }
            });
            console.log('Sent push');
        }

        function subscribe() {
            run().catch(error => console.error(error));
        }
    </script>
</head>

<body>
    Service Worker Demo
    <table>
        <tr>
            <td><label for="server">server url</label></td>
            <td><input type="text" id="server" /></td>
            <td></td>
        </tr>
        <tr>
            <td><label for="server">pub key</label></td>
            <td><input type="text" id="pubkey" /></td>
            <td></td>
        </tr>
        <tr>
            <td><label for="server">user id</label></td>
            <td><input type="number" id="customid" /></td>
            <td><button onclick="subscribe()">subscribe</button></td>
        </tr>
    </table>
</body>

</html>